export async function procEncrypt(messageOptions, publicKeys, openpgp) {

  const message = await openpgp.createMessage(messageOptions);

  const encrypted = await openpgp.encrypt({
    encryptionKeys: publicKeys,
    message,
    format: 'armored',
    config: {
      preferredCompressionAlgorithm: openpgp.enums.compression.zip,
    },
  });

  return encrypted;
}
