export async function feedPassCache(cache_password, keyringCacheType, secretPassString, passwordSessionCachingSalt, openpgp) {

  if (cache_password === '1' && keyringCacheType !== 'keyring') {
    // Cache password.
    await (async () => {
      const message = await openpgp.createMessage({
        text: secretPassString,
      });
      const encrypted = await openpgp.encrypt({
        message,
        passwords: [passwordSessionCachingSalt],
      });
      // Check if an expiration time is already set.
      if (
        sessionStorage.getItem(
          `proc.password_cache_type.key_user_id.${drupalSettings.user.uid}`,
        )
      ) {
        const remainingTime =
          sessionStorage.getItem(
            `proc.password_cache_type.key_user_id.${drupalSettings.user.uid}`,
          ) - new Date().getTime();
        if (remainingTime <= 0) {
          // Remove cached password.
          // removeCachedPassword();
          sessionStorage.removeItem(`proc.password_cache.key_user_id.${drupalSettings.user.uid}`);
          sessionStorage.removeItem(`proc.password_cache_type.key_user_id.${drupalSettings.user.uid}`);

        }
      } else {
        sessionStorage.setItem(
          `proc.password_cache.key_user_id.${drupalSettings.user.uid}`,
          encrypted,
        );
        // If expiration time is set to 1 hour, then count 1 hour from now.
        let expirationTime = new Date().getTime() + 3600000;
        // If expiration time is set to 2 hours, then count 2 hours from now.
        if (keyringCacheType === 'keyring_2h') {
          expirationTime += 3600000;
        }
        sessionStorage.setItem(
          `proc.password_cache_type.key_user_id.${drupalSettings.user.uid}`,
          expirationTime,
        );
      }
    })();
  }

}
