<?php

namespace Drupal\proc\Event;

use Drupal\proc\Element\ProcField;
use Symfony\Contracts\EventDispatcher\Event;

/**
 * Wraps a proc element for event subscribers.
 *
 * @ingroup proc
 */
class ProcElementEvent extends Event {

  /**
   * Processed element.
   *
   * @var Drupal\proc\Element\ProcField
   */
  public $element;

  /**
   * Constructs a proc element event object.
   *
   * @param array $element
   *   The processed proc element.
   */
  public function __construct(ProcField $element) {
    $this->element = $element;
  }

  /**
   * Get the element.
   *
   * @return array
   *   The proc element.
   */
  public function getElement() {
    return $this->element;
  }

  /**
   * Set the element.
   */
  public function setElement($element) {
    $this->element = $element;
  }

}
