<?php

namespace Drupal\proc\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for the cipher entity edit forms.
 */
class CipherForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $result = parent::save($form, $form_state);

    $entity = $this->getEntity();

    $message_arguments = ['%label' => $entity->toLink()->toString()];
    $logger_arguments = [
      '%label' => $entity->label(),
      'link' => $entity->toLink($this->t('View'))->toString(),
    ];

    switch ($result) {
      case SAVED_NEW:
        $this->messenger()
          ->addStatus($this->t('New cipher %label has been created.', $message_arguments));
        $this->logger('proc')
          ->notice('Created new cipher %label', $logger_arguments);
        break;

      case SAVED_UPDATED:
        $this->messenger()
          ->addStatus($this->t('The cipher %label has been updated.', $message_arguments));
        $this->logger('proc')
          ->notice('Updated cipher %label.', $logger_arguments);
        break;
    }

    $form_state->setRedirect('entity.cipher.canonical', ['cipher' => $entity->id()]);

    return $result;
  }

}
