<?php

namespace Drupal\Proc\Form;

use Drupal\Core\Form\FormBase;
use Drupal\proc\Entity\Proc;

/**
 * Base class for Proc Cryptographic Operation forms.
 */
abstract class ProcOpFormBase extends FormBase {

  /**
   * Create or update the Proc entity.
   *
   * @param int|false $field_default_proc_id
   *   The default proc ID.
   *
   * @return \Drupal\proc\Entity\Proc
   *   The Proc entity.
   */
  public function createOrUpdateProcEntity($field_default_proc_id): Proc {
    $proc = Proc::create();
    if ($field_default_proc_id && is_numeric($field_default_proc_id)) {
      $proc_entity = Proc::load($field_default_proc_id);
      if ($proc_entity && $proc_entity->getOwnerId() == $this->currentUser->id()) {
        $proc = $proc_entity;
      }
    }
    return $proc;
  }

}
